Bug 1718997 (python-pyfim) - Review Request: python-pyfim - Frequent Item Set Mining and Association Rule Induction
Summary: Review Request: python-pyfim - Frequent Item Set Mining and Association Rule ...
Keywords:
Status: CLOSED ERRATA
Alias: python-pyfim
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro python-elephant
TreeView+ depends on / blocked
 
Reported: 2019-06-10 17:42 UTC by Ankur Sinha (FranciscoD)
Modified: 2019-06-23 10:23 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-06-23 01:45:55 UTC
anto.trande: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2019-06-10 17:42:22 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-pyfim/python-pyfim.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pyfim/python-pyfim-6.28-1.fc30.src.rpm

Description: 

PyFIM is an extension module that makes several frequent item set mining
implementations available as functions in Python 2.7.x & 3.5.x. Currently
apriori, eclat, fpgrowth, sam, relim, carpenter, ista, accretion and apriacc
are available as functions, although the interfaces do not offer all of the
options of the command line program. (Note that lcm is available as an
algorithm mode of eclat.) There is also a "generic" function fim, which is
essentially the same function as fpgrowth, only with a simplified interface
(fewer options). Finally, there is a function arules for generating association
rules (simplified interface compared to apriori, eclat and fpgrowth, which can
also be used to generate association rules.

How to use the functions can be seen in the example scripts testfim.py and
testacc.py in the source package (directory pyfim/ex). From a Python script or
command prompt interface, call help(fim), help(apriori) (or help(fim.apriori)),
help(eclat) (or help(fim.eclat)) etc. or print, for example, apriori.__doc__,
eclat.__doc__ etc. for a description of the functions and their arguments.

This extension module was originally developed for Python 2.7. The shared
objects made available above were compiled particularly for Python 2.7.11 and
Python 3.5.1 on Ubuntu 16.04 LTS and the dynamic modules made available above
were compiled for Python 2.7.10 and Python 3.5.1 on Windows 10.


Fedora Account System Username: ankursinha

Comment 1 Antonio 2019-06-12 09:22:59 UTC
Hi Ankur.

Test command does not exist:

+ cd pyfim-6.28
+ /usr/bin/python3 setup.py test
BUILDSTDERR: usage: setup.py [global_opts] cmd1 [cmd1_opts] [cmd2 [cmd2_opts] ...]
BUILDSTDERR:    or: setup.py --help [cmd1 cmd2 ...]
BUILDSTDERR:    or: setup.py --help-commands
BUILDSTDERR:    or: setup.py cmd --help
BUILDSTDERR: error: invalid command 'test'
BUILDSTDERR: error: Bad exit status from /var/tmp/rpm-tmp.0UPjGt (%check)

Have you tested the src rpm with Mock?

> %{python3_sitearch}/fim.cpython-37m-*.so

Use the macros:

%{python3_sitearch}/fim.cpython-%{python3_version_nodots}$(python3-config --abiflags)-*.so

Comment 2 Ankur Sinha (FranciscoD) 2019-06-12 21:19:35 UTC
(In reply to Antonio Trande from comment #1)
> Hi Ankur.

Heya,

Thanks for the review :)


> Test command does not exist:
> 
> + cd pyfim-6.28
> + /usr/bin/python3 setup.py test
> BUILDSTDERR: usage: setup.py [global_opts] cmd1 [cmd1_opts] [cmd2
> [cmd2_opts] ...]
> BUILDSTDERR:    or: setup.py --help [cmd1 cmd2 ...]
> BUILDSTDERR:    or: setup.py --help-commands
> BUILDSTDERR:    or: setup.py cmd --help
> BUILDSTDERR: error: invalid command 'test'
> BUILDSTDERR: error: Bad exit status from /var/tmp/rpm-tmp.0UPjGt (%check)
> 
> Have you tested the src rpm with Mock?

Yeh, here's another scratch build:

https://koji.fedoraproject.org/koji/taskinfo?taskID=35509974

The tests are disabled using the `bcond`. I've left that in there so that if upstream does include tests in the future, we can enable them easily.


> > %{python3_sitearch}/fim.cpython-37m-*.so
> 
> Use the macros:
> 
> %{python3_sitearch}/fim.cpython-%{python3_version_nodots}$(python3-config --abiflags)-*.so

This doesn't work for me somehow. So I've left out the `python3-config...` bit.


Here are the updated spec/srpm:

Spec URL: https://ankursinha.fedorapeople.org/python-pyfim/python-pyfim.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-pyfim/python-pyfim-6.28-1.fc30.src.rpm

Comment 3 Antonio 2019-06-13 17:00:33 UTC
Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "*No copyright* GNU
     Lesser General Public License". 222 files have unknown license.
     Detailed output of licensecheck in
     /home/sagitter/FedoraReview/1718997-python-pyfim/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-pyfim
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-pyfim-6.28-1.fc31.x86_64.rpm
          python-pyfim-debugsource-6.28-1.fc31.x86_64.rpm
          python-pyfim-6.28-1.fc31.src.rpm
python3-pyfim.x86_64: W: spelling-error %description -l en_US apriori -> prior
python3-pyfim.x86_64: W: spelling-error %description -l en_US fpgrowth -> growth
python3-pyfim.x86_64: W: spelling-error %description -l en_US sam -> SAM, mas, Sam
python3-pyfim.x86_64: W: spelling-error %description -l en_US relim -> prelim, relic, Selim
python3-pyfim.x86_64: W: spelling-error %description -l en_US ista -> vista, iota, is ta
python3-pyfim.x86_64: W: spelling-error %description -l en_US apriacc -> priapic
python3-pyfim.x86_64: W: spelling-error %description -l en_US lcm -> LCM, cm, lam
python3-pyfim.x86_64: W: spelling-error %description -l en_US fim -> dim, fum, fin
python3-pyfim.x86_64: W: spelling-error %description -l en_US arules -> rules, a rules
python3-pyfim.x86_64: W: spelling-error %description -l en_US testfim -> fittest
python3-pyfim.x86_64: W: spelling-error %description -l en_US testacc -> testate
python3-pyfim.x86_64: W: no-documentation
python-pyfim.src: W: spelling-error %description -l en_US apriori -> prior
python-pyfim.src: W: spelling-error %description -l en_US fpgrowth -> growth
python-pyfim.src: W: spelling-error %description -l en_US sam -> SAM, mas, Sam
python-pyfim.src: W: spelling-error %description -l en_US relim -> prelim, relic, Selim
python-pyfim.src: W: spelling-error %description -l en_US ista -> vista, iota, is ta
python-pyfim.src: W: spelling-error %description -l en_US apriacc -> priapic
python-pyfim.src: W: spelling-error %description -l en_US lcm -> LCM, cm, lam
python-pyfim.src: W: spelling-error %description -l en_US fim -> dim, fum, fin
python-pyfim.src: W: spelling-error %description -l en_US arules -> rules, a rules
python-pyfim.src: W: spelling-error %description -l en_US testfim -> fittest
python-pyfim.src: W: spelling-error %description -l en_US testacc -> testate
3 packages and 0 specfiles checked; 0 errors, 23 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
sh: /usr/bin/python: No such file or directory
/usr/share/rpmlint/Pkg.py:168: UnicodeWarning: decode() called on unicode string, see https://bugzilla.redhat.com/show_bug.cgi?id=1693751
  s.decode('UTF-8')
python3-pyfim.x86_64: W: spelling-error %description -l en_US apriori -> prior
python3-pyfim.x86_64: W: spelling-error %description -l en_US fpgrowth -> growth
python3-pyfim.x86_64: W: spelling-error %description -l en_US sam -> SAM, mas, Sam
python3-pyfim.x86_64: W: spelling-error %description -l en_US relim -> prelim, relic, Selim
python3-pyfim.x86_64: W: spelling-error %description -l en_US ista -> vista, iota, is ta
python3-pyfim.x86_64: W: spelling-error %description -l en_US apriacc -> priapic
python3-pyfim.x86_64: W: spelling-error %description -l en_US lcm -> LCM, cm, lam
python3-pyfim.x86_64: W: spelling-error %description -l en_US fim -> dim, fum, fin
python3-pyfim.x86_64: W: spelling-error %description -l en_US arules -> rules, a rules
python3-pyfim.x86_64: W: spelling-error %description -l en_US testfim -> fittest
python3-pyfim.x86_64: W: spelling-error %description -l en_US testacc -> testate
python3-pyfim.x86_64: W: invalid-url URL: http://www.borgelt.net/pyfim.html <urlopen error [Errno -2] Name or service not known>
/usr/share/rpmlint/Pkg.py:168: UnicodeWarning: decode() called on unicode string, see https://bugzilla.redhat.com/show_bug.cgi?id=1693751
  s.decode('UTF-8')
python3-pyfim.x86_64: W: no-documentation
python-pyfim-debugsource.x86_64: W: invalid-url URL: http://www.borgelt.net/pyfim.html <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 14 warnings.



Unversioned so-files
--------------------
python3-pyfim: /usr/lib64/python3.7/site-packages/fim.cpython-37m-x86_64-linux-gnu.so

Source checksums
----------------
http://www.borgelt.net/src/pyfim.tar.gz :
  CHECKSUM(SHA256) this package     : ae118eed90f4f64a94e0e99b74e03ffdea810e099b5658189e01449f57550910
  CHECKSUM(SHA256) upstream package : ae118eed90f4f64a94e0e99b74e03ffdea810e099b5658189e01449f57550910


Requires
--------
python3-pyfim (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython3.7m.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)

python-pyfim-debugsource (rpmlib, GLIBC filtered):



Provides
--------
python3-pyfim:
    python3-pyfim
    python3-pyfim(x86-64)
    python3.7dist(fim)
    python3dist(fim)

python-pyfim-debugsource:
    python-pyfim-debugsource
    python-pyfim-debugsource(x86-64)



Generated by fedora-review 0.7.2 (c486bbd) last change: 2019-04-30
Command line :./try-fedora-review -m fedora-rawhide-x86_64 -b 1718997
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api, Python
Disabled plugins: fonts, PHP, Perl, Java, Ruby, SugarActivity, Ocaml, R, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Gwyn Ciesla 2019-06-14 13:17:05 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyfim

Comment 5 Fedora Update System 2019-06-14 16:01:06 UTC
FEDORA-2019-37b2e313a3 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-37b2e313a3

Comment 6 Fedora Update System 2019-06-14 16:01:07 UTC
FEDORA-2019-37b2e313a3 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-37b2e313a3

Comment 7 Fedora Update System 2019-06-14 16:31:40 UTC
FEDORA-2019-7442f74aa9 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7442f74aa9

Comment 8 Fedora Update System 2019-06-15 02:08:34 UTC
python-elephant-0.6.2-3.fc30, python-pyfim-6.28-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-37b2e313a3

Comment 9 Fedora Update System 2019-06-15 02:16:02 UTC
python-elephant-0.6.2-3.fc29, python-neo-0.8.0-0.1.20190215git49b6041.fc29, python-pyfim-6.28-1.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7442f74aa9

Comment 10 Fedora Update System 2019-06-23 01:45:55 UTC
python-elephant-0.6.2-3.fc30, python-pyfim-6.28-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2019-06-23 10:23:06 UTC
python-elephant-0.6.2-3.fc29, python-neo-0.8.0-0.1.20190215git49b6041.fc29, python-pyfim-6.28-1.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.